Deployment Pipelines - Deploy Stage Content
Deploys items from the specified stage of the specified deployment pipeline.
To learn about items that are supported in deployment pipelines, see: Supported items.
This API supports long running operations (LRO).
Permissions
The caller must have an admin deployment pipelines role. The user must be at least a contributor on both source and target deployment workspaces. For more information, see: Permissions.
Required Delegated Scopes
Pipeline.Deploy
Limitations
Maximum 300 deployed items per request.
Microsoft Entra supported identities
This API supports the Microsoft identities listed in this section.
| Identity | Support |
|---|---|
| User | Yes |
| Service principal and Managed identities | Only supported when all the items involved in the operation support service principals |
Interface
POST https://api.fabric.microsoft.com/v1/deploymentPipelines/{deploymentPipelineId}/deploy
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
deployment
|
path | True |
string (uuid) |
The deployment pipeline ID. |
Request Body
| Name | Required | Type | Description |
|---|---|---|---|
| sourceStageId | True |
string (uuid) |
The ID of the source stage. |
| targetStageId | True |
string (uuid) |
The ID of the target stage. |
| createdWorkspaceDetails |
The configuration details for creating a new workspace. Required when deploying to a stage that has no assigned workspaces, otherwise it is ignored. The deployment will fail if the new workspace configuration details aren't provided when required. |
||
| items |
A list of items to be deployed. If not used, all supported stage items are deployed. |
||
| note |
string maxLength: 1024 |
A note describing the deployment. The text size is limited to 1024 characters. |
|
| options |
Deployment options that control the behavior of the deployment. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Request completed successfully. |
|
| 202 Accepted |
Request accepted, deployment is in progress. Headers
|
|
| 429 Too Many Requests |
The service rate limit was exceeded. The server returns a Headers Retry-After: integer |
|
| Other Status Codes |
Common error codes:
|
Examples
Example of deploying all Fabric items (such as reports or dashboards) from a deployment pipeline stage
Sample request
POST https://api.fabric.microsoft.com/v1/deploymentPipelines/a5ded933-57b7-41f4-b072-ed4c1f9d5824/deploy
{
"sourceStageId": "db1577e0-0132-4d6d-92b9-952c359988f2",
"targetStageId": "f1c39546-6282-4590-8af3-847a6226ad16",
"note": "Deploying business ready items"
}
Sample response
Location: https://api.fabric.microsoft.com/v1/operations/431e8d7b-4a95-4c02-8ccd-6faef5ba1bd7
x-ms-operation-id: 431e8d7b-4a95-4c02-8ccd-6faef5ba1bd7
deployment-id: 1065e6a3-a020-4c0c-ada7-92b5fe99eec5
Retry-After: 30
Example of deploying specific Fabric items (such as reports or dashboards) from a deployment pipeline stage
Sample request
POST https://api.fabric.microsoft.com/v1/deploymentPipelines/a5ded933-57b7-41f4-b072-ed4c1f9d5824/deploy
{
"sourceStageId": "db1577e0-0132-4d6d-92b9-952c359988f2",
"targetStageId": "f1c39546-6282-4590-8af3-847a6226ad16",
"items": [
{
"sourceItemId": "6bfe235c-6d7b-41b7-98a6-2b8276b3e82b",
"itemType": "Datamart"
},
{
"sourceItemId": "1a201f2a-d1d8-45c0-8c61-1676338517de",
"itemType": "SemanticModel"
},
{
"sourceItemId": "2d225191-65f8-4ec3-b77d-06100602b1f7",
"itemType": "Report"
},
{
"sourceItemId": "9046e4cc-8aea-4a7a-a3b5-1a78b1447d82",
"itemType": "Dashboard"
},
{
"sourceItemId": "7f08923c-8f57-49d6-a010-8335bb9cbd1b",
"itemType": "Dashboard"
}
],
"note": "Deploying business ready items"
}
Sample response
Location: https://api.fabric.microsoft.com/v1/operations/431e8d7b-4a95-4c02-8ccd-6faef5ba1bd7
x-ms-operation-id: 431e8d7b-4a95-4c02-8ccd-6faef5ba1bd7
deployment-id: 1065e6a3-a020-4c0c-ada7-92b5fe99eec5
Retry-After: 30
Example of deploying with options
Sample request
POST https://api.fabric.microsoft.com/v1/deploymentPipelines/a5ded933-57b7-41f4-b072-ed4c1f9d5824/deploy
{
"sourceStageId": "db1577e0-0132-4d6d-92b9-952c359988f2",
"targetStageId": "f1c39546-6282-4590-8af3-847a6226ad16",
"items": [
{
"sourceItemId": "6bfe235c-6d7b-41b7-98a6-2b8276b3e82b",
"itemType": "Report"
}
],
"note": "Deploying with options",
"options": {
"allowCrossRegionDeployment": false,
"itemOptionsBySourceItemId": [
{
"sourceItemId": "6bfe235c-6d7b-41b7-98a6-2b8276b3e82b",
"options": {
"validateOnly": true
}
}
]
}
}
Sample response
Location: https://api.fabric.microsoft.com/v1/operations/431e8d7b-4a95-4c02-8ccd-6faef5ba1bd7
x-ms-operation-id: 431e8d7b-4a95-4c02-8ccd-6faef5ba1bd7
deployment-id: 1065e6a3-a020-4c0c-ada7-92b5fe99eec5
Retry-After: 30
Definitions
| Name | Description |
|---|---|
|
Deployment |
A deployment execution plan. |
|
Deployment |
A deployment execution step. |
|
Deployment |
Deployment configuration options for the deployment. |
|
Deployment |
The configuration details for creating a new workspace. Required when deploying to a stage that has no assigned workspaces. |
|
Deployment |
A Fabric deployment pipeline operation. |
|
Deployment |
A note describing the deployment. |
|
Deployment |
The status of the deployment pipeline operation. Additional statuses may be added over time. |
|
Deployment |
The operation type. Additional types may be added over time. |
|
Deployment |
Source and target items. |
|
Deploy |
A request to deploy items from a deployment pipeline stage to another consecutive stage. Deploying to a previous stage can be done only when the target stage is empty. If no items were specified, will deploy all supported items from the deployment pipeline stage, otherwise will deploy only the specified items. |
|
Entire |
Represents a tenant principal |
|
Error |
A structured parameter providing additional machine-readable context about an error. |
|
Error |
The error related resource details object. |
|
Error |
The error response. |
|
Error |
The error response details. |
|
Group |
Group specific details. Applicable when the principal type is |
|
Group |
Represents a security group. |
|
Group |
The type of the group. Additional group types may be added over time. |
|
Item |
A request to deploy a Fabric item (such as a report or a dashboard). |
|
Item |
A per-item options entry that targets its item by source item ID. Each targeted item may appear at most once. |
|
Item |
Specifies if an item is new, different or identical to items in the target stage before deployment. Additional states may be added over time. |
|
Item |
The type of the item. Additional item types may be added over time. |
|
Pre |
The number of new, different and identical deployed items before deployment. |
|
Principal |
The type of the principal. Additional principal types may be added over time. |
|
Service |
Service principal specific details. Applicable when the principal type is |
|
Service |
Represents a Microsoft Entra service principal. |
|
Service |
Service principal profile details. Applicable when the principal type is |
|
Service |
Represents a service principal profile. |
|
User |
User principal specific details. Applicable when the principal type is |
|
User |
Represents a Microsoft Entra user principal. |
DeploymentExecutionPlan
A deployment execution plan.
| Name | Type | Description |
|---|---|---|
| steps |
The collection of execution plan steps. |
DeploymentExecutionStep
A deployment execution step.
| Name | Type | Description |
|---|---|---|
| description |
string |
The deployment step description. |
| error |
The error details. Only applicable if the deployment pipeline operation failed. |
|
| index |
integer |
The step index. |
| preDeploymentDiffState |
Is an item new, different or identical to items in the target stage before deployment. |
|
| sourceAndTarget |
The source and target items of the step. |
|
| status |
The status of the deployment pipeline operation. Additional statuses may be added over time. |
DeploymentOptions
Deployment configuration options for the deployment.
| Name | Type | Description |
|---|---|---|
| allowCrossRegionDeployment |
boolean |
Indicates whether cross region deployment is enabled. True - enabled, False - disabled. Default value is false. |
| itemOptionsBySourceItemId |
Per-item deployment options. Each entry targets its item by source item ID and applies its options to that item. |
DeploymentPipelineNewWorkspaceConfiguration
The configuration details for creating a new workspace. Required when deploying to a stage that has no assigned workspaces.
| Name | Type | Description |
|---|---|---|
| capacityId |
string (uuid) |
The ID of the capacity that the new workspace will be assigned to. If unspecified and the API caller has permissions for the source stage workspace capacity, then that capacity will be used. Otherwise, Fabric will select a capacity that the API caller has permissions for. |
| name |
string maxLength: 256 |
The name of the new workspace. |
DeploymentPipelineOperationExtendedInfo
A Fabric deployment pipeline operation.
| Name | Type | Description |
|---|---|---|
| executionEndTime |
string (date-time) |
The date and time that the operation ended. |
| executionPlan |
The deployment execution plan. |
|
| executionStartTime |
string (date-time) |
The date and time that the operation started. |
| id |
string (uuid) |
The operation ID. |
| lastUpdatedTime |
string (date-time) |
The date and time that the operation was last updated. |
| note |
A note representing a description of the operation. |
|
| performedBy | Principal: |
The principal that performed the deployment pipeline operation. |
| preDeploymentDiffInformation |
The number of deployed items in the source stage, that are new, identical or different to items in the target stage, before deployment. |
|
| sourceStageId |
string (uuid) |
The ID of a source deployment pipeline stage. |
| status |
The deployment pipeline operation status. Additional statuses may be added over time. |
|
| targetStageId |
string (uuid) |
The ID of a target deployment pipeline stage. |
| type |
The operation type. Additional types may be added over time. |
DeploymentPipelineOperationNote
A note describing the deployment.
| Name | Type | Description |
|---|---|---|
| content |
string |
Text describing the deployment. |
| isTruncated |
boolean |
Indicates whether the note content is truncated. True - the note content is truncated, False - the note content isn't truncated. Default value is false. |
DeploymentPipelineOperationStatus
The status of the deployment pipeline operation. Additional statuses may be added over time.
| Value | Description |
|---|---|
| NotStarted |
The deployment pipeline operation didn't start. |
| Running |
The deployment pipeline operation is running. |
| Succeeded |
The deployment pipeline operation succeeded. |
| Failed |
The deployment pipeline operation failed. |
DeploymentPipelineOperationType
The operation type. Additional types may be added over time.
| Value | Description |
|---|---|
| Deploy |
Deploy content between stages. |
DeploymentSourceAndTarget
Source and target items.
| Name | Type | Description |
|---|---|---|
| itemType |
The type of the Fabric item that will be overwritten in the target stage. Only applies when overwriting a Fabric item. |
|
| sourceItemDisplayName |
string |
The display name of the Fabric item that's deployed from the source stage. |
| sourceItemId |
string (uuid) |
The ID of the Fabric item that's deployed from the source stage. |
| targetItemDisplayName |
string |
The name of the Fabric item that will be overwritten in the target stage. Only applies when overwriting a Fabric item. |
| targetItemId |
string (uuid) |
The ID of the Fabric item that will be overwritten in the target stage. Only applies when overwriting a Fabric item. |
DeployRequest
A request to deploy items from a deployment pipeline stage to another consecutive stage. Deploying to a previous stage can be done only when the target stage is empty. If no items were specified, will deploy all supported items from the deployment pipeline stage, otherwise will deploy only the specified items.
| Name | Type | Description |
|---|---|---|
| createdWorkspaceDetails |
The configuration details for creating a new workspace. Required when deploying to a stage that has no assigned workspaces, otherwise it is ignored. The deployment will fail if the new workspace configuration details aren't provided when required. |
|
| items |
A list of items to be deployed. If not used, all supported stage items are deployed. |
|
| note |
string maxLength: 1024 |
A note describing the deployment. The text size is limited to 1024 characters. |
| options |
Deployment options that control the behavior of the deployment. |
|
| sourceStageId |
string (uuid) |
The ID of the source stage. |
| targetStageId |
string (uuid) |
The ID of the target stage. |
EntireTenantPrincipal
Represents a tenant principal
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| type |
string:
Entire |
The type of the principal. Additional principal types may be added over time. |
ErrorParameter
A structured parameter providing additional machine-readable context about an error.
| Name | Type | Description |
|---|---|---|
| message |
string |
A human-readable description of the parameter's meaning. |
| name |
string |
The parameter identifier. |
| value |
string |
The parameter value. |
ErrorRelatedResource
The error related resource details object.
| Name | Type | Description |
|---|---|---|
| resourceId |
string |
The resource ID that's involved in the error. |
| resourceType |
string |
The type of the resource that's involved in the error. |
ErrorResponse
The error response.
| Name | Type | Description |
|---|---|---|
| errorCode |
string |
A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users. |
| isRetriable |
boolean |
When true, the request can be retried. Use the |
| message |
string |
A human readable representation of the error. |
| moreDetails |
List of additional error details. |
|
| parameters |
Structured parameters providing additional machine-readable context about the error. |
|
| relatedResource |
The error related resource details. |
|
| requestId |
string (uuid) |
ID of the request associated with the error. |
ErrorResponseDetails
The error response details.
| Name | Type | Description |
|---|---|---|
| errorCode |
string |
A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users. |
| message |
string |
A human readable representation of the error. |
| parameters |
Structured parameters providing additional machine-readable context about the error. |
|
| relatedResource |
The error related resource details. |
GroupDetails
Group specific details. Applicable when the principal type is Group.
| Name | Type | Description |
|---|---|---|
| groupType |
The type of the group. Additional group types may be added over time. |
GroupPrincipal
Represents a security group.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| groupDetails |
Group specific details. Applicable when the principal type is |
|
| id |
string (uuid) |
The principal's ID. |
| type |
string:
Group |
The type of the principal. Additional principal types may be added over time. |
GroupType
The type of the group. Additional group types may be added over time.
| Value | Description |
|---|---|
| Unknown |
Principal group type is unknown. |
| SecurityGroup |
Principal is a security group. |
| DistributionList |
Principal is a distribution list. |
ItemDeploymentRequest
A request to deploy a Fabric item (such as a report or a dashboard).
| Name | Type | Description |
|---|---|---|
| itemType |
The Fabric item type. |
|
| sourceItemId |
string (uuid) |
The ID of the Fabric item to be deployed. |
ItemOptionsBySourceItemIdEntry
A per-item options entry that targets its item by source item ID. Each targeted item may appear at most once.
| Name | Type | Description |
|---|---|---|
| options |
object |
The options for the targeted item. Property names are option names valid for the item type; values are the option values. For the options supported by a specific item type, see that item type's |
| sourceItemId |
string (uuid) |
The source item ID of the target item. |
ItemPreDeploymentDiffState
Specifies if an item is new, different or identical to items in the target stage before deployment. Additional states may be added over time.
| Value | Description |
|---|---|
| New |
A new deployed item that doesn't exist in the target stage. |
| Different |
Before deployment, the item in the source stage wasn't identical to the one in the target stage. |
| NoDifference |
Before deployment, the item in the source stage was identical to the one in the target stage. |
ItemType
The type of the item. Additional item types may be added over time.
| Value | Description |
|---|---|
| Dashboard |
PowerBI dashboard. |
| Report |
PowerBI report. |
| SemanticModel |
PowerBI semantic model. |
| PaginatedReport |
PowerBI paginated report. |
| Datamart |
PowerBI datamart. |
| Lakehouse |
A lakehouse. |
| Eventhouse |
An eventhouse. |
| Environment |
An environment. |
| KQLDatabase |
A KQL database. |
| KQLQueryset |
A KQL queryset. |
| KQLDashboard |
A KQL dashboard. |
| DataPipeline |
A data pipeline. |
| Notebook |
A notebook. |
| SparkJobDefinition |
A spark job definition. |
| MLExperiment |
A machine learning experiment. |
| MLModel |
A machine learning model. |
| Warehouse |
A warehouse. |
| Eventstream |
An eventstream. |
| SQLEndpoint |
An SQL endpoint. |
| MirroredWarehouse |
A mirrored warehouse. |
| MirroredDatabase |
A mirrored database. |
| Reflex |
A Reflex. |
| GraphQLApi |
An API for GraphQL item. |
| MountedDataFactory |
A MountedDataFactory. |
| SQLDatabase |
A SQLDatabase. |
| CopyJob |
A Copy job. |
| VariableLibrary |
A VariableLibrary. |
| Dataflow |
A Dataflow. |
| ApacheAirflowJob |
An ApacheAirflowJob. |
| WarehouseSnapshot |
A Warehouse snapshot. |
| DigitalTwinBuilder |
A DigitalTwinBuilder. |
| DigitalTwinBuilderFlow |
A Digital Twin Builder Flow. |
| MirroredAzureDatabricksCatalog |
A mirrored azure databricks catalog. |
| Map |
A Map. |
| AnomalyDetector |
An Anomaly Detector. |
| UserDataFunction |
A User Data Function. |
| GraphModel |
A GraphModel. |
| GraphQuerySet |
A Graph QuerySet. |
| SnowflakeDatabase |
A Snowflake Database to store Iceberg tables created from Snowflake account. |
| OperationsAgent |
A OperationsAgent. |
| CosmosDBDatabase |
A Cosmos DB Database. |
| Ontology |
An Ontology. |
| EventSchemaSet |
An EventSchemaSet. |
| DataAgent |
A DataAgent. |
| MirroredCatalog |
A MirroredCatalog. |
| PolicySet |
A PolicySet. |
| AppBackend |
An AppBackend. |
| OrgApp |
An Org App. |
| OrgAppAudience |
An Org App Audience. |
| DataBuildToolJob |
A DataBuildToolJob. |
| AzureDatabricksStorage |
A OneLake-backed storage item for Azure Databricks. |
| Plan |
A plan. |
PreDeploymentDiffInformation
The number of new, different and identical deployed items before deployment.
| Name | Type | Description |
|---|---|---|
| differentItemsCount |
integer |
The number of deployed items with differences between source and target stages, before deployment. |
| newItemsCount |
integer |
The number of new items deployed to the target stage. |
| noDifferenceItemsCount |
integer |
The number of identical deployed items in the source and target stages, before deployment. |
PrincipalType
The type of the principal. Additional principal types may be added over time.
| Value | Description |
|---|---|
| User |
Principal is a Microsoft Entra user principal. |
| ServicePrincipal |
Principal is a Microsoft Entra service principal. |
| Group |
Principal is a security group. |
| ServicePrincipalProfile |
Principal is a service principal profile. |
| EntireTenant |
Principal represents all tenant users. |
ServicePrincipalDetails
Service principal specific details. Applicable when the principal type is ServicePrincipal.
| Name | Type | Description |
|---|---|---|
| aadAppId |
string (uuid) |
The service principal's Microsoft Entra AppId. |
ServicePrincipalPrincipal
Represents a Microsoft Entra service principal.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| servicePrincipalDetails |
Service principal specific details. Applicable when the principal type is |
|
| type |
string:
Service |
The type of the principal. Additional principal types may be added over time. |
ServicePrincipalProfileDetails
Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.
| Name | Type | Description |
|---|---|---|
| parentPrincipal | Principal: |
The service principal profile's parent principal. |
ServicePrincipalProfilePrincipal
Represents a service principal profile.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| servicePrincipalProfileDetails |
Service principal profile details. Applicable when the principal type is |
|
| type |
string:
Service |
The type of the principal. Additional principal types may be added over time. |
UserDetails
User principal specific details. Applicable when the principal type is User.
| Name | Type | Description |
|---|---|---|
| userPrincipalName |
string |
The user principal name. |
UserPrincipal
Represents a Microsoft Entra user principal.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
The principal's display name. |
| id |
string (uuid) |
The principal's ID. |
| type |
string:
User |
The type of the principal. Additional principal types may be added over time. |
| userDetails |
User principal specific details. Applicable when the principal type is |